#ifndef __BALL_H
#define __BALL_H

#include "vec3.h"
#include "aabb.h"
#include "model.h"
#include "shapes.h"
#include "rigid.h"

class Ball {
	Sphere s;
	BSphere bs;
	Rigid_body body;
public:
	Ball(const Vec3 &p, float r) : s(r, 20, 20), bs(p, r), body(p) { }
	// member get
	const Vec3& pos() const { return bs.pos(); }
	const Vec3& vel() const { return body.vel(); }
	//const Vec3& accel() const { return body.accel(); }
	float r() const { return bs.r(); }
	const BSphere& bsphere() const { return bs; }
	// member set
	void pos(const Vec3& p) { bs.pos(p); body.pos(p); }
	void vel(const Vec3& v) { body.vel(v); }
	void accel(const Vec3& a) { body.accel(a); }
	void r(float radius) { bs.r(radius); }
	// utility
	void move(float dt) { body.move(dt); bs.pos(body.pos()); }
	void draw() const { s.draw(); }
};

#endif
