#ifndef __BRICK_H
#define __BRICK_H
#include "vec3.h"
#include "aabb.h"
#include "model.h"
#include "shapes.h"

class Brick {
	AABB aabb_;
	QuadCube cube;  // cube could be shared if dimensions are equal and offsets are 0
public:
	Brick() {}
	Brick(const Vec3 &p, const Vec3 &e) : aabb_(p, e) {
		cube.init(e.x*2, e.y*2, e.z*2);
	}
	const Vec3& pos() const { return aabb_.pos(); }
	void pos(const Vec3& p) { aabb_.pos(p); }
	void init(const Vec3& p, const Vec3& e) { 
		 aabb_.pos(p); aabb_.extents(e);
		 cube.init(e.x*2, e.y*2, e.z*2);  // QuadCube expects actual side length; ignore pos for now
	}
	void draw() const { cube.draw(); }
	const AABB& aabb() const { return aabb_; }
};

#endif
