#ifndef __GLOBAL_H
#define __GLOBAL_H

#include <kos.h>
#include "color3.h"
#include "vec3.h"

typedef struct {
	float x, y, z;
	uint32 flags;
} VectorF;

extern struct Rcontext rctx;
extern pvr_poly_cxt_t cxt;
extern pvr_poly_hdr_t hdr;

inline uint32 plx_pack_color3(float r, float g, float b) {
	return ( ((uint8)( r * 255 ) ) << 16 ) | 
	( ((uint8)( g * 255 ) ) << 8 ) | 
	( ((uint8)( b * 255 ) ) << 0 ) ;
}
inline uint32 plx_pack_color3(Color3 &c) {
	return plx_pack_color3(c.r, c.g, c.b);
}

inline void plx_mat3d_translate(const Vec3 &v) {
	plx_mat3d_translate(v.x, v.y, v.z);
}

#define plx_pack_alpha(a) (( ((uint8)( a * 255 )) << 24))

#endif
