#ifndef __MODEL_H
#define __MODEL_H

#include "global.h"
#include "vec3.h"

class Model;
class QuadModel;
void draw_model(const Model& m);
void draw_model(const QuadModel& m);

class Model {
public:
	VectorF *data;
	VectorF *data_xform;
	Vec3 *normals;
	uint32 *lit_color;
	int nvert;
	uint16 nindices;
	uint16 ndups;
public:
	Model() {}
	void draw() const { draw_model(*this); }
	void invalidate_lighting() const {  // Is const qualifier okay here?
		// sq_clr doesn't work reliably here, not sure why.
		memset(lit_color, 0, nindices * sizeof(uint32));
	}
};

// template<int nfacevtx> class FacetModel
class QuadModel {
public:
	Vec3 *data;
	Vec3 *data_xform;
	Vec3 *normals;
	uint16 nvert;
	uint16 nfaces;
	static const int nfacevtx = 4;
	struct facedata {
		float pn;  // precalculated position * normal for culling
		uint16 vtx[nfacevtx];
	};
	facedata *faces;
public:
	QuadModel() {}
	void draw() const { draw_model(*this); }
	void invalidate_lighting() const {} // no-op

};

#endif
