#ifndef __RIGID_H
#define __RIGID_H

#include "vec3.h"

class Rigid_body {
	Vec3 P;
	Vec3 V;
	Vec3 A;
public:
	Rigid_body(const Vec3& p = Vec3(0,0,0)) : P(p), V(0,0,0), A(0,0,0) {}
	void move(float dt) {
		P += V * dt;
		V += A * dt;
	}
	const Vec3& pos() const { return P; }
	const Vec3& vel() const { return V; }
	void pos(const Vec3& p) { P = p; }
	void vel(const Vec3& v) { V = v; }
	void accel(const Vec3& a) { A = a; }
};

#endif
