#ifndef __SHAPES_H
#define __SHAPES_H

#include "model.h"

class Rectangle {
private:
	void rectangle();
private:
	float h_, w_;
	Model model_;
public:
	Rectangle(float w, float h) : h_(h), w_(w) { this->rectangle(); }
	void draw() const { model_.draw(); }
};

class Cube {
private:
	void create();
private:
	float h_, w_, d_; 
	float xo_, yo_, zo_; // X, Y and Z offsets for object coordinates
	Model model_;
	bool initialized;
public:
	Cube() {}
	Cube(float w, float h, float d, float xo=0, float yo=0, float zo=0) : h_(h), w_(w), d_(d), xo_(xo), yo_(yo), zo_(zo) { this->create(); initialized = true; }
	void draw() const { model_.draw(); }
	void init(float w, float h, float d, float xo=0, float yo=0, float zo=0) {
		assert(!initialized);
		w_=w; h_=h; d_=d; xo_=xo; yo_=yo; zo_=zo;
		this->create();
		initialized = true;
	}

};

class QuadCube {
private:
	void create();
private:
	float h_, w_, d_; 
	float xo_, yo_, zo_; // X, Y and Z offsets for object coordinates
	QuadModel model_;
	bool initialized;
public:
	QuadCube() {}
	QuadCube(float w, float h, float d, float xo=0, float yo=0, float zo=0) : h_(h), w_(w), d_(d), xo_(xo), yo_(yo), zo_(zo) { this->create(); initialized = true; }
	void draw() const { model_.draw(); }
	void init(float w, float h, float d, float xo=0, float yo=0, float zo=0) {
		assert(!initialized);
		w_=w; h_=h; d_=d; xo_=xo; yo_=yo; zo_=zo;
		this->create();
		initialized = true;
	}

};



class Sphere {
private:
	void sphere();

private:
	float radius_;
	int slices_;
	int stacks_;
	Model model_;
public:
	Sphere(float rad, int slic, int stac) : radius_(rad), slices_(slic), stacks_(stac) {
		this->sphere();	
	}
	Model& model() { return model_; }
	void draw() const { model_.draw(); }
};

#endif

